"use strict";
"use client";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
function useInterval(callback, delay) {
    var callbackRef = (0, react_1.useRef)(callback);
    var intervalRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        callbackRef.current = callback;
    }, [callback]);
    var start = (0, react_1.useCallback)(function () {
        if (!intervalRef.current) {
            intervalRef.current = window.setInterval(function () { return callbackRef.current(); }, delay);
        }
    }, [delay]);
    var stop = (0, react_1.useCallback)(function () {
        if (intervalRef.current !== null) {
            clearInterval(intervalRef.current);
            intervalRef.current = null;
        }
    }, []);
    (0, react_1.useEffect)(function () {
        start();
        return stop;
    }, [delay, start, stop]);
    var reset = (0, react_1.useCallback)(function () {
        stop();
        start();
    }, [start, stop]);
    return { start: start, stop: stop, reset: reset };
}
exports.default = useInterval;
