"use client";
import { useCallback, useEffect, useRef } from "react";
export default function useInterval(callback, delay) {
    var callbackRef = useRef(callback);
    var intervalRef = useRef(null);
    useEffect(function () {
        callbackRef.current = callback;
    }, [callback]);
    var start = useCallback(function () {
        if (!intervalRef.current) {
            intervalRef.current = window.setInterval(function () { return callbackRef.current(); }, delay);
        }
    }, [delay]);
    var stop = useCallback(function () {
        if (intervalRef.current !== null) {
            clearInterval(intervalRef.current);
            intervalRef.current = null;
        }
    }, []);
    useEffect(function () {
        start();
        return stop;
    }, [delay, start, stop]);
    var reset = useCallback(function () {
        stop();
        start();
    }, [start, stop]);
    return { start: start, stop: stop, reset: reset };
}
